#!/bin/sh
#
# License: Copyright 2007 SpinetiX S.A. This file is licensed
#          under the terms of the GNU General Public License version 2.
#          This program is licensed "as is" without any warranty of any
#          kind, whether express or implied.
#
# Copyright 1999-2003 MontaVista Software, Inc.
# Copyright 2002, 2003, 2004 Sony Corporation
# Copyright 2002, 2003, 2004 Matsushita Electric Industrial Co., Ltd.
#
### BEGIN INIT INFO
# Required-Start:
# Required-Stop:
# Should-Start:
# Should-Stop:
# Default-Start: S
# Default-Stop: 0 1 2 3 4 5 6
# Short-Description: Config reset mechanism.
# Description: Config reset mechanism.
### END INIT INFO
# chkconfig: S 36 0

# Init script information
INIT_NAME=config
DESC=""

# The file that permanently stores configuration changes so as to be
# robust against reboots while resetting.
BOOTCONFIG=/boot-config

case "$1" in
    start)
        config="$(sed -e 's/.*\bconfig=\([^[:space:]]\+\).*/\1/p;d' < /proc/cmdline)"
	if [ -n "$config" ]; then
	    rm -f "$BOOTCONFIG"
	elif [ -f "$BOOTCONFIG" ]; then
	    config="$(< "$BOOTCONFIG" )"
	fi
	if [ -z "$config" ]; then
	    exit 0;
	fi
	echo "$config" > "$BOOTCONFIG"
	if [ $? -ne 0 ]; then
	    echo "Failed saving configuration request '$config' to '$BOOTCONFIG'" >&2
	fi
	sync

        # NOTE: the list of supported configuration tags must be entered in
        # /etc/spinetix/boot-config-tags.
	case "$config" in
	    reset)
	    echo '!!!! RESETTING CONFIGURATION !!!!'
	    for f in /etc/spinetix/config.d/*; do
		echo DOING "$(basename $f)"
		$f reset
	    done
	    echo 'DONE'
	    ;;
	    dhcp-nfs)
	    echo -n "Resetting network configuration to DHCP with NFS"
	    /etc/spinetix/spxsysconf dhcp
	    echo "."
	    ;;
	    dhcp|static=*)
	    echo -n "Resetting network configuration to '$config'"
	    /etc/spinetix/spxsysconf net "$config"
	    echo "."
	    ;;
	esac

	rm -f "$BOOTCONFIG"
	sync

    ;;
    stop)
    ;;
esac
