#!/bin/sh
#
# chkconfig: S 38 0
#
# Extracts kernel options and creates
# the corresponding files.

NETINSTALL=/etc/default/netinstall

# Outputs kernel options, one per line
function kopts() {
    tr ' \t' '\n' < /proc/cmdline
}

case "$1" in
    start|restart)
    kopts | sed -e '/^netinstall=[a-z]\+:/{s,.*=,,;p};d' > $NETINSTALL
    if [ ! -s $NETINSTALL ]; then
	rm -f $NETINSTALL
    fi
    if kopts | grep -q '^dhcp$' ; then
	touch /etc/enable-dhcp
    else
	rm -f /etc/enable-dhcp
    fi
    ;;
    stop|reload|force-reload)
    ;;
esac
