#!/bin/sh
#
# chkconfig: S 60 0
#
# Recovers some PID files that are created before /var/run is cleaned
# due to init script ordering blunder from MV.

dhcpcd_pid_get() {
    local pid="$(pgrep -x dhcpcd-bin)"
    if [ -n "$pid" ]; then
	echo "$pid" > /var/run/dhcpcd-eth0.pid
    fi
}

case "$1" in
    start|restart)
    dhcpcd_pid_get
    ;;
    stop|reload|force-reload)
    ;;
esac

