<?php
/*
 * Created on 6 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */
$title="Player"; 
include ("prolog.php");

$spxNS = 'http://www.spinetix.com/namespace/1.0/spx';
$svgNS = 'http://www.w3.org/2000/svg';
$xlinkNS = 'http://www.w3.org/1999/xlink';

$config_name="/srv/raperca/spxconfig.xml";
//echo "$config_name<br/>";
// apply changes 
$input=$_POST;
$tags=array("priority","host", "minStepFactor", "href","fps","profiling","hurry-up","update-fps","cachegroup","timestamp","name","description","location","group","mute");
$sources=array();
foreach ($input as $name=>$val){
	
	foreach ($tags as $tag){
		$key=$tag.'_';
		$n=strlen($key);
		if (strncmp ($name,$key,$n)==0){
			$sources[substr($name,$n)][$tag]=$val;
		}
	}	
}
$config = new DOMDocument;
$config->loadXML(file_get_contents($config_name));

if (isset($input["update"]) ){
	foreach($sources as $id => $val){
		$source = $config->getElementById($id);
		if (!isset($source)) {
			$source = $config->getElementsByTagName($id);
			if ( $source->length >=1 ) $source = $source->item(0);
		}
		if (!isset($source)) continue;
		foreach ($tags as $tag){
			if (array_key_exists($tag,$val)){
				if ($tag=="href") {
					$source->setAttributeNS($xlinkNS,$tag,$val[$tag]);
				}
				else $source->setAttribute($tag,$val[$tag]);
			}	
		}
	}
	
	$serverIdx=0;
	$vHosts=$config->getElementsByTagName('virtualHost');
	$vHostList=array();
	foreach ($vHosts as $vHost) $vHostList[]=$vHost;
	foreach ($vHostList as $vHost) $vHost->parentNode->removeChild($vHost);
	$parent=$config->getElementsByTagName('resource');
	if ($parent->length<1) $parent=$source->appendChild($config->createElement('resource'));
	else $parent=$parent->item(0);
	while (isset($input['servername'.$serverIdx]) && isset($input['serverhref'.$serverIdx])){
		$name=$input['servername'.$serverIdx];
		$href=$input['serverhref'.$serverIdx];
		if ($name!="" && $href!=""){
			$vHost=$config->createElement('virtualHost');
			$vHost->setAttribute("host", "project://$name");
			$vHost->setAttributeNS($xlinkNS,"xlink:href", $href);
			$vHost->setAttribute("xml:id", "virtualHost_".$serverIdx);
			$parent->appendChild($vHost);
		}
		$serverIdx++;
	}
	
	save_file($config_name,$config->saveXML(), true);
}

$hosts = $config->getElementsByTagName('virtualHost');
$hostlist=array();
foreach ($hosts as $host){
	$hostname=$host->getAttribute("host");
	$hostsplit=split("/",$hostname);
	$hostAdress=$host->getAttributeNS($xlinkNS,"href");
	$hostlist[]=array($hostsplit[2],$hostAdress, $hostname);
}

?>

<script type="text/javascript">
<![CDATA[

function addNewServer()
{
	var tableServer=document.getElementById("serverDef");
	var nbServer=tableServer.rows.length-1;
	var newRow=tableServer.insertRow(nbServer+1);
	var text1="<td><input size='20' type='text' name='servername" + nbServer + "' value='MyServer"+ nbServer +"' onchange='updateServerName()' /><\/td>\n";
	var text2="<td><input size='40' type='text' name='serverhref" + nbServer + "' value='http://MyServer_uri/MyPath/'/><\/td>\n";
	newRow.innerHTML=text1+text2;
}
]]>
</script>

<form action="advplayerconfig.php" method="post">

<h2>Source: </h2>
The player will open the following sources from top to bottom. If the first source is not available, then the second one will be opened, and so on.
<table>
<?php
$sources = $config->getElementsByTagName('sources');
foreach ($sources as $source){
	$nodelist=array();
	foreach ($source->childNodes as $node){
		if ($node->nodeType==XML_ELEMENT_NODE){
			$prio=$node->getAttribute("priority");
			$nodelist[$prio]=$node;	
		}
	}
	krsort($nodelist);
	
	foreach ($nodelist as $prio => $node){
			
		$id=$node->getAttribute("xml:id");
		if (!isset($id) || !$id) $id=$node->getAttribute("id");
		echo "<tr><td><input  type='hidden' name=\"", htmlspecialchars("priority_$id"), "\" value=\"", htmlspecialchars($prio), "\"/>\n";
		echo "<input size='63' type='text' name=\"", htmlspecialchars("href_$id"), "\" value=\"", htmlspecialchars($node->getAttributeNS($xlinkNS,"href")), "\"/></td>\n</tr>\n";
		
	}
}
?>
</table>

<h2>Network Sources: </h2>
Use the table below to define the location of the network sources.  
<table id="serverDef">
<tr><td>Server name</td><td>URI</td><td><input type="button" value="Add server row" onclick="addNewServer()" /></td></tr>
<?php

$hostIdx=0;
$maxHostIdx=5;

foreach ($hostlist as $server){
     echo "<tr><td><input size='20' type='text' name=\"", htmlspecialchars("servername$hostIdx"), "\" value=\"", htmlspecialchars($server[0]), "\" onchange='updateServerName()' /></td>\n";
     echo "<td><input size='40' type='text' name=\"", htmlspecialchars("serverhref$hostIdx"), "\" value=\"", htmlspecialchars($server[1]), "\"/></td>\n</tr>\n";
	$hostIdx++;
}
?>
</table>

<h2>Settings: </h2>
<table>
<?php
$svglibs = $config->getElementsByTagName('svglib');
$sets=array("profiling"=>"Profiling", "fps"=>"Show fps", "cachegroup"=>"Debug cache group", "timestamp"=>"Show timestamp" );
foreach ($svglibs as $svglib){
	$id=$svglib->getAttribute("xml:id");
	if (!isset($id) || !$id) $id=$svglib->getAttribute("id");
	if (!isset($id) || !$id) $id="svglib";
	foreach ($sets as $name => $val){
		$isOn = $svglib->getAttribute($name)=='on' || $svglib->getAttribute($name)=='true';
	    echo "<tr><td>$val</td><td>on<input type='radio' name=\"${name}_$id\" value='on' ";
		if ($isOn) print ("checked='checked' ");
		print ("/></td>");
		echo "<td>off<input  type='radio' name=\"${name}_$id\" value='off' ";
		if (!$isOn) print ("checked='checked' ");
		print ("/></td></tr>\n");
	}
}
$svgrenders = $config->getElementsByTagName('svgrender');
$sets=array("update-fps"=>"Update FPS", "hurry-up"=>"Hurry-up" );
foreach ($svgrenders as $svgrender){
	$id=$svgrender->getAttribute("xml:id");
	if (!isset($id) || !$id) $id=$svgrender->getAttribute("id");
	if (!isset($id) || !$id) $id="svgrender";
	foreach ($sets as $name => $val){
		$isOn = $svgrender->getAttribute($name)=='on' || $svgrender->getAttribute($name)=='true'; 
	    echo "<tr><td>$val</td><td>on<input type='radio' name=\"${name}_$id\" value='on' ";
		if ($isOn) print ("checked='checked' ");
		print ("/></td>");
		echo "<td>off<input  type='radio' name=\"${name}_$id\" value='off' ";
		if (!$isOn) print ("checked='checked' ");
		print ("/></td></tr>\n");
	}
}

?>
</table>
<?php
echo "Minimum Step Factor : <input size='3' type='text' name=\"minStepFactor_$id\" value=\"", htmlspecialchars($svgrender->getAttribute("minStepFactor")), "\" /><br/>";
?>
<input type="submit" value="Apply" name="update" />
</form>
<?php
include "final.php";
?>