<?php

 header("Content-type: text/xml");
 
$spxNS = 'http://www.spinetix.com/namespace/1.0/spxconf';

function addItem($name, $value, $node) {
	global $output;
	
	$item = $output->createElement($name);
	$text = $output->createTextNode($value);
	$node->appendChild($item);
	$item->appendChild($text);
	$node->appendChild($output->createTextNode("\n"));
	
}


$deviceType="HMP100";

// Serial number
$cpuinfo=file_get_contents("/proc/cpuinfo");
if (preg_match("/Serial\W+0000(\w+)/",$cpuinfo,$match))
	$serial=$match[1];
else
	$serial="001d50xxxxxx";

// hardware revision
if (preg_match("/Revision\W+:\s+(\w+)/",$cpuinfo,$match)){
	$val=hexdec($match[1]);
	$hwrdRevision=floor($val/65536).".".($val % 65536);
}else
	$hwrdRevision="x.x";
	
//check safe mode
$safemode=file_exists("/var/run/raperca.safe");


// uptime
$uptime=file_get_contents("/proc/uptime");
$uptime=explode(" ",$uptime);
$uptime = $uptime[0];

// IP configuration
$ipstr=exec('ip -o -f inet addr show dev eth0');
$ip="";
$prefixLength="";
$res=preg_match("@inet\s+([0-9.]+)/([0-9]+)\s+@", $ipstr, $ipvals);
if ($res!=0){
	$ip=$ipvals[1];
	$prefixLength=$ipvals[2];
} 
	


// IP configuration
$ipconfig="static";
$address="";
$netmask="";
$gateway="";
$interface=file_get_contents("/etc/network/interfaces");
if (!($interface===false)) {
	$start=strpos($interface,"# START-spxsysconfig DO NOT REMOVE THE START AND END TAGS");
	$end=strpos($interface,"# END-spxsysconfig");
	if (!($start===false || $end===false)) {
		$str1="iface eth0 inet ";
		$iface=strpos($interface,$str1, $start);
		$iface+=strlen($str1);
		$conf=substr($interface,$iface,$end-$iface);
		$vals=explode ("\n",$conf);	
		
		if (trim($vals[0])=="dhcp"){
			$ipconfig="dhcp";
		}elseif (trim($vals[0])=="static"){
			$ipconfig="static";
			foreach ($vals as $name){
				if (!(($n=strpos($name,"address "))===false)){
					$address=trim(substr($name, strlen("address")+$n));
				}elseif (!(($n=strpos($name,"netmask "))===false)){
					$netmask=trim(substr($name, strlen("netmask")+$n));
				}elseif (!(($n=strpos($name,"gateway "))===false)){
					$gateway=trim(substr($name, strlen("gateway")+$n));
				}
			}
		}	
	}
}
$dns="";
if ($ipconfig=="static") {
	$dnsfile=file_get_contents("/etc/network/resolv.conf.static");
	$i=1;
	$pos=strpos($dnsfile,"nameserver");
	while (!($pos===false)){
		$pos+=strlen("nameserver");
		$name="nameserver".$i; 
		$i++;
		$dns[$name]=trim(substr($dnsfile,$pos,strpos($dnsfile,"\n",$pos)-$pos));
		$dnsfile=substr($dnsfile,strpos($dnsfile,"\n",$pos));
		$pos=strpos($dnsfile,"nameserver");
	}
}
	
	
$config_name="/srv/raperca/spxconfig.xml";
$spxconf=file_get_contents($config_name);
$deviceName="";
$screenId="";
$scanpercent="";
$orientation="";
$maxLatency="";
$interactLatency="";
$enableAudio="off";
$remoteClientsEnabled="false";
$sharedVarPort="1234";
if ($spxconf) {
	$domdoc = new DOMDocument;
	$domdoc->loadXML($spxconf);
	$multiscreen=$domdoc->getElementsByTagName("multiscreen");
	if ($multiscreen->length==1){
		$multiscreen=$multiscreen->item(0);
		if ($multiscreen->hasAttribute("screenId")) $screenId=$multiscreen->getAttribute("screenId");
	}
	$reporting=$domdoc->getElementsByTagName("reporting");
	if ($reporting->length==1){
		$reporting=$reporting->item(0);
		if ($reporting->hasAttribute("deviceName")) $deviceName=$reporting->getAttribute("deviceName");
	}
	if ($deviceName=="") $deviceName=$serial;
	if ($screenId=="") $screenId=$serial;
	
	$svglib=$domdoc->getElementsByTagName("svglib");
	if ($svglib->length==1){
		$svglib=$svglib->item(0);
		if ($svglib->hasAttribute("mute")) $enableAudio=$svglib->getAttribute("mute");
	}else unset($svglib);
	
	$svgrender=$domdoc->getElementsByTagName("svgrender");
	if ($svgrender->length==1){
		$svgrender=$svgrender->item(0);
		if ($svgrender->hasAttribute("overScanMargin")) $scanpercent=$svgrender->getAttribute("overScanMargin");
		if ($svgrender->hasAttribute("screenOrientation")) $orientation=$svgrender->getAttribute("screenOrientation");
		if ($svgrender->hasAttribute("maxLatency")) $maxLatency=$svgrender->getAttribute("maxLatency");
		if ($svgrender->hasAttribute("interactLatency")) $interactLatency=$svgrender->getAttribute("interactLatency");
	}else unset($svgrender);
	
	$interactivity=$domdoc->getElementsByTagName("interactivity");
	if ($interactivity->length==1){
		$interactivity=$interactivity->item(0);
		if ($interactivity->hasAttribute("remoteClientsEnabled")) $remoteClientsEnabled=$interactivity->getAttribute("remoteClientsEnabled");
		if ($interactivity->hasAttribute("sharedVarPort")) $sharedVarPort=$interactivity->getAttribute("sharedVarPort");
	}else unset($interactivity);
}

// Screen info
$vidmod=file_get_contents("/sys/class/graphics/fb0/device/vid_mode");
$sets=explode ("=",$vidmod);
$refresh="";
$aspectratio="x:x";
if (count($sets)==2){
	$vals=explode (" ",trim($sets[1]));
	if (count($vals)>=11){
		$resolutionW = $vals[0];
		$resolutionH = $vals[1];
		$refresh = $vals[2];
		$aspectratio = $vals[11];
	}
}

$dir="/sys/class/graphics/fb0/device/";
$content=scandir($dir);
$screeninfo = array();
foreach($content as $path){
	if (strncmp($path,"out",3)==0){
		$data=array("mon_powered","mon_manufacturer","mon_prod_id", "mon_name","mon_serial_no", "mon_width","mon_height","mon_underscan","mon_audio","mon_pict_ar","link_type" );
		$name=file_get_contents("$dir$path/name");
		$mon_present=file_get_contents("$dir$path/mon_present");
		$scinfo = array();
		if ($mon_present==1) {
			foreach ($data as $d){
				${$d}=file_get_contents($dir.$path."/$d");
				if (!isset(${$d})) ${$d}="";
			}
			if ($mon_manufacturer!="" || $mon_name!="") {
				$scinfo['manufacturer']=$mon_manufacturer;
				$scinfo['productID']=$mon_prod_id;
				$scinfo['name']=$mon_name;
				$scinfo['serial']=$mon_serial_no;
			}
			if ($mon_powered!="" ) $scinfo['powered']=$mon_powered==0?"off":"on";
			else $scinfo['powered']="unknown";
		
			if ($mon_pict_ar=="" || $mon_pict_ar=="x:x") $mon_pict_ar="[unknown]";
			if ($mon_width!="" && $mon_height!="") {
				$scinfo['width']=$mon_width;
				$scinfo['height']=$mon_height;
				$scinfo['aspectRatio']=$mon_pict_ar;
			}
			$scinfo['link']=$link_type;
			if ($mon_underscan!="" && $mon_underscan==0) $scinfo['underscan']="unsupported"; else $scinfo['underscan']="supported";
		}
		$screeninfo[$name]=$scinfo;
	}
}


// Storage size
function isMounted($dir) {
     $mount=file_get_contents("/proc/mounts");
     $mounts=explode("\n",$mount);
     foreach ($mounts as $mount){
	  $info=preg_split("/\s/",$mount);
	  if ($info[1]==$dir)
	       return TRUE;
     }
     return FALSE;
}
function printUsageTable($path, $name, $node) {
	global $output;
	
	$di = $output->createElement(trim($name));
	$node->appendChild($di);
	$di->appendChild($output->createTextNode("\n"));
	
	$info=exec('df -B 1048576 -P '.$path);
	
	$spaces=preg_split("@\s+@",$info);
	
	$avail=$spaces[3];
    $used=$spaces[2];
    $tot=$spaces[1];

	
	
	addItem("available", $avail, $di);
	addItem("used", $used, $di);
	addItem("total", $tot, $di);
	addItem("unit", "Mbytes", $di);	
	
	$node->appendChild($output->createTextNode("\n"));
}

// firmware
$release = file_get_contents('/etc/spinetix-release');
$vals=explode(" ", $release);
$firmware="error";
$build="error";
if (count($vals)==6 ){
	$firmware = $vals[3];
	$build = $vals[5];
}


//timezone
$realpath=readlink("/etc/localtime");
$inf=split("/",$realpath);
$tzarea=$inf[count($inf)-2];
$tzcity=$inf[count($inf)-1];

// Pull mode:
// load the config
$config = new DOMDocument;
$config->loadXML(file_get_contents('/etc/raperca/uploaderconf.xml'));
$schedule=$config->getElementsByTagName("schedule");
$selectMode="Disabled";
if ($schedule->length>0) {
	$link=$schedule->item(0)->getAttributeNS($xlinkNS,"href");
	if ($link=="uploader.ics") {
		$selectMode = "Automatic";
	} else {
		$selectMode = "Server";
		$icalsource = preg_replace("@$serial@","[serial]",$link);
	}
} else {
	// manual
	
	$proj=$config->getElementsByTagName("action");
	foreach ($proj as $action) {
		$name=$action->getAttribute("summary");
		if ($name=='publish') {
			$enable_project = 1;
			$project_source=$action->getAttributeNS($xlinkNS,"href");
			$time1 = $action->getAttribute("time");
			$selectMode = "Manual";
		}
		if ($name=='upload') {
			$enable_log = 1;
			$logsource=$action->getAttributeNS($xlinkNS,"href");
			$time2 = $action->getAttribute("time");
			$logs=$action->getAttribute("type");
			$selectMode = "Manual";
		}
	}
}


$output = new DOMDocument;

$main = $output->createElementNs($spxNS,"status");
$output->appendChild($main);

// device info
$device = $output->createElement("device");
$main->appendChild($device);
$device->appendChild($output->createTextNode("\n"));
addItem("name", $deviceType, $device);
addItem("serial", $serial, $device);
addItem("revision", $hwrdRevision, $device);

$main->appendChild($output->createTextNode("\n"));


// status
$status = $output->createElement("status");
$main->appendChild($status);
$status->appendChild($output->createTextNode("\n"));
addItem("safemode", $safemode?"on":"off", $status);
addItem("uptime", $uptime, $status);  
$main->appendChild($output->createTextNode("\n"));

// time
$time = $output->createElement("time");
$main->appendChild($time);
$time->appendChild($output->createTextNode("\n"));
addItem("date",date("F j, Y, G:i"), $time);
addItem("timezone","$tzarea/$tzcity", $time);
addItem("GMTOffset",date("P"), $time);
$main->appendChild($output->createTextNode("\n"));


// network info
$network = $output->createElement("network");
$main->appendChild($network);
$network->appendChild($output->createTextNode("\n"));
addItem("deviceName", $deviceName, $network);
addItem("ip", $ip, $network);
addItem("prefixLength", $prefixLength, $network);

addItem("configuration", $ipconfig, $network);
if ($ipconfig=="static") {
	addItem("address", $address, $network);
	addItem("netmask", $netmask, $network);
	addItem("gateway", $gateway, $network);
	foreach($dns as $name)
		addItem("dns", $name, $network);
}

$main->appendChild($output->createTextNode("\n"));


// screen info
$screen = $output->createElement("screen");
$main->appendChild($screen);
$screen->appendChild($output->createTextNode("\n"));
addItem("screenID", $screenId, $screen);
addItem("snapshotURI", "http://".$ip."/snapshot/snapshot.php", $screen);
addItem("resolutionWidth", $resolutionW, $screen);
addItem("resolutionHeight", $resolutionH, $screen);
addItem("verticalRefresh", $refresh, $screen);
addItem("aspectRatio", $aspectratio, $screen);
addItem("overscanPercent", $scanpercent, $screen);
addItem("orientation", $orientation, $screen);

$ad = $output->createElement("audio");
$screen->appendChild($ad);
$ad->appendChild($output->createTextNode("\n"));
addItem("mute", $enableAudio, $ad);
$screen->appendChild($output->createTextNode("\n"));

foreach ($screeninfo as $name => $sc) {
	$di = $output->createElement("display");
	$screen->appendChild($di);
	$di->appendChild($output->createTextNode("\n"));
	addItem("name",trim($name), $di);
	foreach ($sc as $name1 => $info) {
		addItem($name1, $info, $di);		
	}
	$screen->appendChild($output->createTextNode("\n"));
}

$main->appendChild($output->createTextNode("\n"));

// storage
$storage = $output->createElement("storage");
$main->appendChild($storage);
$storage->appendChild($output->createTextNode("\n"));
printUsageTable("/srv/.shadow-raperca", "content", $storage);
printUsageTable("/", "system", $storage);
$path = realPath("../content");
if ( isMounted($path) )
	printUsageTable($path, "usb", $storage);

$main->appendChild($output->createTextNode("\n"));

// firmware
$version = $output->createElement("version");
$main->appendChild($version);
$version->appendChild($output->createTextNode("\n"));
$fi = $output->createElement("firmware");
$version->appendChild($fi);
$fi->appendChild($output->createTextNode("\n"));
addItem("version", $firmware, $fi);
addItem("build", $build, $fi);

$main->appendChild($output->createTextNode("\n"));


// pull mode
$uploader = $output->createElement("uploader");
$main->appendChild($uploader);
$uploader->appendChild($output->createTextNode("\n"));
addItem("mode", $selectMode, $uploader);
if ($selectMode=="Manual") {
	if ($enable_project) {
		addItem("projectSource", $project_source, $uploader);
		addItem("projectTime", $time1, $uploader);
	}
	if ($enable_log) {
		addItem("logDestination", $logsource, $uploader);
		addItem("logTime", $time2, $uploader);
	}
}else if ($selectMode=="Server"){
	addItem("calendar", $icalsource, $uploader);
}



echo $output->saveXML();
?>
