<?php
/*
 * Created on 6 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */
$title="Date/Time"; 
include ("prolog.php");

# The list of predefined boot delays for NTP, the maximum
# delay available should take account of the kernel's maximum
# watchdog auto-ping time and the worst case time it
# takes to start the system in the abscence of the boot pause.
$bootdelays = array('0', '90', '120', '150');

function checked($val) {
     if (isset($val) && $val!="")
	  return "checked='checked'";
     else
	  return "";
}

class ntpconfig{
	var $fname="/etc/spinetix/spx-ntp.conf";
	var $fname2="/etc/default/ntpdate";
	var $fname3="/etc/default/bootpause";
	var $active;
	var $server="";
	var $nr_servers=0;
	var $nr_sync_servers=0;
	var $bootdelay=0;
	function load(){
		$this->bootdelay=0;
		if (preg_match('/^BOOTPAUSE=\"*([^\"\s]+)/m',
			       file_get_contents($this->fname3), $matches)) {
		     $this->bootdelay=$matches[1];
		}
		$ntpconf=file_get_contents($this->fname);
		$this->active=false;
		$this->nr_servers=0;
		$this->nr_sync_servers=0;
		if (!isset($ntpconf) && $ntpconf) return;
	
		$lines = explode("\n", $ntpconf);
		foreach ($lines as $line) {
		     if (preg_match('/^\s*server\s+(\S+)(.*)/', $line, $matches)) {
			  $this->nr_servers++;
			  $name="ntpserver".$this->nr_servers;
			  $nosel="ntpnosel".$this->nr_servers;
			  $this->$name = $matches[1];
			  if (strpos($matches[2],"noselect") === false) {
			       $this->$nosel = "";
			       $this->nr_sync_servers++;
			  } else {
			       $this->$nosel = "yes";
			  }
		     }
		}
		$this->active=($this->nr_servers>0);
	}
	function save(){
		$startupserver="";
		$startup_ips="";
		$gopts="iburst";
		$lopts="minpoll 4 maxpoll 8";
		$acopts="nomodify notrap";
		$conf="# Local ntp configuration\n"; # Should not be empty
		if ( ! isset($this->bootdelay) || $this->bootdelay == "" )
		     $this->bootdelay = 0;
		else if ( ! is_numeric($this->bootdelay)
			  || ! (((string)(int)$this->bootdelay) === $this->bootdelay)
			  || $this->bootdelay < 0) {
		     echo "<p style='color:red'>Error: '" .
			  htmlspecialchars($this->bootdelay) .
			  "' is not a valid delay; " .
			  "configuration not saved.</p>\n";
		     return false;
		}
		for ($i=1; $i<=5; $i++){
			$name="ntpserver".$i;
			$nosel="ntpnosel".$i;
			if (isset($this->$name) && $this->$name!=""){
				if ( has_shell_metachars($this->$name) ||
				     preg_match('/\s/',$this->$name) )
				{
				     echo "<p style='color:red'>Error: '",
					  htmlspecialchars($this->$name),
					  "' is not a valid NTP server; " .
					  "configuration not saved.</p>\n";
				     return false;
				}
				# Do not add extra options to default / pool servers
				$sopts = $gopts;
				if ( ! preg_match("/pool.ntp.org\s*$/", $this->$name) )
				     $sopts .= " " . $lopts;
				if (isset($this->$nosel) && $this->$nosel!="")
				     $sopts .= " noselect";
				$conf .= "server " . $this->$name . " " . $sopts . "\n" .
				     "restrict " . $this->$name . " mask 255.255.255.255 " .
				     $acopts . "\n";
				if (ip_check($this->$name)) {
				     $startup_ips .= " " . $this->$name;
				} else {
				     $startupserver=$this->$name;
				}
			}
		}
		# Having many servers by IP for startup is OK, but having more
		# than one by name is tropublesome due to large delays when
		# name resolution when DNS servers are unreachable
		if ($startup_ips) {
		     $startupserver = ('"' . $startupserver . " " . $startup_ips . '"');
		}
		$ok=save_file($this->fname,$conf);
		//boot time server:
		$txt=
		     "#\n" .
		     "#       Configuration file for ntpdate.\n" .
		     "#       Copyright(C) 2004-2005, MontaVista Software, Inc.\n" .
		     "#\n" .
		     "\n" .
		     "#\n" .
		     "#       NTPSERVERS\n" .
		     "#       Specify timeserver for time synchronization here.\n" .
		     "#\n";
		$conf=$txt."NTPSERVERS=$startupserver\n";
		$ok &=  save_file($this->fname2,$conf);

		$pause_conf = file_get_contents($this->fname3);
		$val = ( $this->bootdelay ? $this->bootdelay : '' );
		$pause_conf = preg_replace('/^BOOTPAUSE=.*/m',"BOOTPAUSE=". $val, $pause_conf);
		$ok &= save_file($this->fname3,$pause_conf);

		return $ok;
	}
}
 
$ntp=new ntpconfig;
$ntp->load();

// find all the time zones:
$tzarea='Etc';
$tzcity='GMT';
$file="/var/spool/spxutils/dateadjust";
$reboot=false;
$modntp=0;
if (isset($_POST['tzupdate'])){
	exec("rm -f /etc/localtime && ln -sf ".$_POST['tzcity']." /etc/localtime");
	exec("sync");
	$reboot=true;
}
if (isset($_POST['timeupdate'])){
	
	$vals=array("ntpserver1","ntpserver2","ntpserver3", "ntpserver4", "ntpserver5",
		    "ntpnosel1","ntpnosel2","ntpnosel3", "ntpnosel4", "ntpnosel5",
		    "bootdelay");
	foreach ($vals as $name){
		if (!isset($_POST[$name])) $_POST[$name]=""; 
		if (isset($_POST[$name]) && $ntp->$name!=trim($_POST[$name])) {
		     $modntp=1;
		     $ntp->$name=trim($_POST[$name]);
		}
	}
	if ($modntp)
		$reboot=$ntp->save();
	
	
	if (isset($_POST['manualtime']) && $_POST['manualtime']){
		$updateOffset=0;
		$now=time();
		if (isset($_POST['dateday']) && isset($_POST['datemonth']) && isset($_POST['dateyear'])){
			$_POST['date']=$_POST['dateday']."-".$_POST['datemonth']."-".$_POST['dateyear'];
		}
		if (isset($_POST['timeh']) && isset($_POST['timem']) && isset($_POST['times'])){
			$_POST['time']=$_POST['timeh'].":".$_POST['timem'].":".$_POST['times'];
		}
		if (isset($_POST['date']) && $_POST['date']!=""){
			$in=strtotime($_POST['date']);
			$ref=strtotime("00:00:00",$now);
			if ($in!=false){
				$updateOffset+=$in-$ref;
			}else{
			     echo "Date ".htmlspecialchars($_POST['date'])." is not a valid date, not applied<br/>";
			}
		}
		if (isset($_POST['time']) && $_POST['time']!=""){
			$in=strtotime($_POST['time']);
			if ($in!=false){
				$updateOffset+=$in-$now;
			}else{
			     echo "Time ".htmlspecialchars($_POST['time'])." is not a valid time, not applied<br/>";
			}
		}
		if ($updateOffset!=0){
			$Days = round($updateOffset/(60*60*24));
			$Hours = round(($updateOffset-($Days*60*60*24))/(60*60));
			$Minutes = round(($updateOffset-($Days*60*60*24)-($Hours*60*60))/60);
			$Sec = $updateOffset-($Days*60*60*24)-($Hours*60*60)-($Minutes*60);
			//echo "Setting offset: $Days day $Hours hour $Minutes min $Sec sec";
			$reboot=save_file($file,"$Days day $Hours hour $Minutes min $Sec sec");
		}
	}
}

function printNTPStats($nr_sync_servers) {
     static $tally = array(
	  ' ' => 'reject',
	  'x' => 'bad', // falseticker
	  '.' => 'discard', // excess
	  '-' => 'outlier',
	  '+' => 'candidate',
	  '#' => 'selected',
	  '*' => 'peer',
	  'o' => 'peer');
     # Codes from http://doc.ntp.org/4.2.0/debug.html
     static $refidmsg = array(
	  '.ACST.' => 'anycast',
	  '.AUTH.' => 'auth failed',
	  '.AUTO.' => 'autokey failed',
	  '.BCST.' => 'broadcast',
	  '.CRYP.' => 'crypto failed',
	  '.DENY.' => 'denied',
	  '.DROP.' => 'dropped',
	  '.RSTR.' => 'restricted',
	  '.INIT.' => 'initializing',
	  '.MCST.' => 'manycast',
	  '.NKEY.' => 'no key',
	  '.RATE.' => 'rate exceeded',
	  '.RMOT.' => 'remote control',
	  '.STEP.' => 'step change');

     exec("ntpq -n -c 'timeout 300' -c peers", $stdout, $status);
     $ntpd_stat = stat('/var/run/ntpd.pid');
     $ntpd_started = ($ntpd_stat ? $ntpd_stat['mtime'] : 0);
     if ($status != 0 || count($stdout) < 2) {
	  if ($ntpd_started + 60*5 >= time()) {
	       echo "<p>NTP service was recently restarted (",
		    time() - $ntpd_started, " seconds ago), please " .
		    "wait a few minutes until it gathers statistics " .
		    "and refresh this page.</p>\n";
	  } else {
	       echo "<p>Failed querying local NTP service.</p>\n";
	  }
	  return -1;
     }
     echo "<table cellpadding='3'>\n";
     echo "<tr>";
     echo "<th align='left'>Server IP</th>\n" .
	  "<th align='right'>Stratum</th>\n" .
	  "<th align='right'>Status</th>\n" .
	  "<th align='right'>Reach</th>\n" .
	  "<th align='right'>Time offset</th>\n" .
	  "<th align='right'>Delay</th>\n" .
	  "<th align='right'>Dispersion</th>\n" .
	  "<th align='right'>Poll interval</th>\n";
     echo "</tr>";
     $nr_servers = 0;
     $nr_peers = 0;
     for ($i=2; $i<count($stdout); $i++) {
	  $server_status = substr($stdout[$i],0,1);
	  $data = preg_split('/\s+/', substr($stdout[$i],1));
	  $server_refid = $data[1];
	  $server_type = $data[3];
	  if ($server_type != 'l') { // do not count local server
	       $nr_servers++;
	       $server_ip = $data[0];
	       if ($server_status == '*' || $server_status == 'o') {
		    $nr_peers++;
	       }
	  } else {
	       $server_ip = 'loopback';
	  }
	  $server_stratum = $data[2];
	  $server_poll = $data[5];
	  // the reachability register is a shifting log of the
	  // successful / failed status of the last 8 polls printed out in octal
	  $server_reachbits = intval($data[6],8);
	  $server_reach = 0;
	  while ($server_reachbits) {
	       if (($server_reachbits & 1) != 0)
		    $server_reach++;
	       $server_reachbits = ($server_reachbits >> 1);
	  }
	  $server_reach = $server_reach / 8;
	  $server_delay = $data[7];
	  $server_offset = $data[8];
	  $server_jitter = $data[9];
	  echo "<tr>\n";
	  echo "<td align='left'>", htmlspecialchars($server_ip), "</td>\n";
	  echo "<td align='right'>".($server_reach != 0 ? $server_stratum : "-")."</td>\n";
	  echo "<td align='right'>";
	  if ($refidmsg[$server_refid]) {
	       echo $refidmsg[$server_refid];
	  } else if ($server_reach != 0 || $server_status != ' ') {
	       echo ($tally[$server_status] ? $tally[$server_status] : 'unknown');
	  } else {
	       echo ('unreachable');
	  }
	  echo "</td>\n";
	  echo "<td align='right'>".round($server_reach*100)." %</td>\n";
	  echo "<td align='right'>".($server_reach != 0 ? round($server_offset)." ms" : "-")."</td>\n";
	  echo "<td align='right'>".($server_reach != 0 ? round($server_delay)." ms" : "-")."</td>\n";
	  echo "<td align='right'>".($server_reach != 0 ? round($server_jitter)." ms" : "-")."</td>\n";
	  echo "<td align='right'>$server_poll s</td>\n";
	  echo "</tr>\n";
     }
     echo "</table>\n";
     if ($nr_peers == 0 && $nr_sync_servers != 0) {
	  echo "<p><b>WARNING</b>: there are currently no external NTP peers and thus " .
	       "this device is currently not time synchronized.<br/>\n";
	  if ($ntpd_started + 60*8 > time()) { // allow for a few minutes for ntpd to start sync
	       echo "The NTP service was recently restarted (", time() - $ntpd_started, " " .
		    "seconds ago) so this may be a harmless transient situation while NTP " .
		    "gathers statistics, please refresh this page in a few minutes.<br/>\n";
	       echo "However, if this situation persists, " .
		    "synchronized playback and timely display are not possible. \n";
	  } else {
	       echo "Synchronized playback and timely display are not possible. \n";
	  }
	  echo "Most common causes are firewalls preventing NTP network traffic (UDP port " .
	       "123), NTP servers which have no reference clock or have recently restarted, " .
	       "or mistyped NTP server addresses.</p>";
     }
     $drift_file = '/var/lib/spx-ntp/drift';
     $drift = trim(file_get_contents($drift_file));
     if ( $drift == 0 ) { // catches empty and non-existent drift file as well
	  if ($nr_peers == 0) {
	       if ( is_numeric($drift) && $drift == 0 ) {
		    echo "<p><b>WARNING</b>: the local clock is calibrated with " .
			 "a dummy value of zero from the loopback reference.\n";
	       } else {
		    echo "<p><b>WARNING</b>: the local clock is not calibrated.\n";
	       }
	       echo "To calibrate configure at least one NTP server so that it " .
		    "is reachable and can become a peer. Calibration starts " .
		    "automatically when external peers are found and takes " .
		    "60 minutes.<br/>\n";
	  } else {
	       if ( is_numeric($drift) && $drift == 0 ) {
		    echo "<p><b>WARNING</b>: the local clock is calibrated with " .
			 "a dummy value of zero from the loopback reference " .
			 "but calibration is ongoing,\n";
	       } else {
		    echo "<p><b>WARNING</b>: the local clock is not calibrated but " .
			 "calibration is ongoing,\n";
	       }
	       echo "keep this device running without " .
		    "interruption for at least 60 minutes with a reachable " .
		    "external NTP peer for calibration to complete.<br/>\n";
	  }
	  echo "An uncalibrated local clock severely degrades time synchronization and " .
	       "makes the device's clock drift away from real time much more rapidly " .
	       "when no NTP servers are reachable. Calibration is a one time process, " .
	       "initial calibration data is kept across reboots and updated as necessary.\n";
	  echo "</p>\n";
     } else {
	  echo "<p>The local clock is calibrated (saved correction is ",
              htmlspecialchars($drift), " ppm).</p>\n";
	  if ( $drift < -80 || $drift > 80 ) {
              echo "<p><b>WARNING</b>: the value of the saved correction is unusually large. " .
                  "This is often indicative of a malfunctioning NTP server. Verify that your NTP " .
                  "servers are working reliably. Once the NTP servers are working reliably the " .
                  "calibration will be smoothly corrected automatically, but this is a long " .
                  "process. You may restart the calibration from scratch by resetting it " .
                  "from the maintenance page.</p>\n";
	  }
     }
     return $nr_servers;

}

if ($reboot){
     shutdown("time config changed");
}else{
	
$realpath=readlink("/etc/localtime");
$inf=split("/",$realpath);
$tzarea=$inf[count($inf)-2];
$tzcity=$inf[count($inf)-1];

$path="/usr/share/zoneinfo";
$filelist=scandir($path);
natsort($filelist);

?>

<h2>Current Settings: </h2>
<table>
  <tr>
    <td >Local time : </td>
    <td ><?php print(date("F j, Y, G:i")); ?></td>
  </tr>
  <tr>
    <td >Time Zone : </td>
    <td ><?php print("$tzarea/$tzcity GMT".date("P")); ?></td>
  </tr>
</table>

<h2>Change Time Zone: </h2>
<form action="timesettings.php" method="post">

<?php

$timezones=array();
foreach($filelist as $file){
	if ($file[0]!='.' && is_dir($path."/".$file) ) {
		$area=array();
		$tzpath=$path."/".$file;
		$tzfilelist=scandir($tzpath);
		natsort($tzfilelist);
		foreach($tzfilelist as $tzfile){
			if ($tzfile[0]=='.' || is_dir($tzpath."/".$tzfile) ) continue;
			$area[$tzfile]=$tzpath."/".$tzfile;
		}	
		$timezones[$file]=$area;
	}
}
?>
<script type="text/javascript">
<!--
var timezonesCity=new Array();
var timezonesUri=new Array();
<?php

$idx=0;
$tzmap=array("Africa" => "Africa", "America" => "America", "US" => "US time zones", "Canada" => "Canada time zones",
			 "Asia" => "Asia", "Atlantic" => "Atlantic Ocean", "Australia" => "Australia", "Europe" => "Europe",
			 "Indian" => "Indian Ocean", "Pacific" => "Pacific Ocean");
foreach ($timezones as $name => $val){
	$cities="";
	$uris="";
	if (isset($tzmap[$name])){
		foreach ($val as $city => $uri){
			$cities.="'$city',";
			$uris.="'$uri',";		
		}
		$cities=substr($cities,0,strlen($cities)-1);
		$uris=substr($uris,0,strlen($uris)-1);
	
		echo "timezonesCity[$idx]=new Array($cities);\n";
		echo "timezonesUri[$idx]=new Array($uris);\n";
		$idx++;
	}
}

?>
function selectRegion()
{
	var selectRegion=document.getElementById("RegionSelect");
	var selectCity=document.getElementById("CitySelect");
	var reg=selectRegion.selectedIndex;
	var nbCity=selectCity.length;
	for (var i=0; i<nbCity; i++){
		selectCity.remove(0);
	}
	nbCity=timezonesCity[reg].length;
	for (var i=0; i<nbCity; i++){
		var newOption=new Option;
		newOption.text=timezonesCity[reg][i];
		newOption.value=timezonesUri[reg][i];
		try {
			selectCity.add(newOption, null);
		}catch(ex) {
			selectCity.add(newOption);
		}
	}
}

function timeSettings(isManual)
{
	
	document.getElementById("DateDaySelect").disabled=!isManual;
	document.getElementById("DateMonthSelect").disabled=!isManual;
	document.getElementById("DateYearSelect").disabled=!isManual;
	document.getElementById("TimeHSelect").disabled=!isManual;
	document.getElementById("TimeMSelect").disabled=!isManual;
	document.getElementById("TimeSSelect").disabled=!isManual;
	
	document.getElementById("NtpServer1").disabled=isManual;
	document.getElementById("NtpServer2").disabled=isManual;
	document.getElementById("NtpServer3").disabled=isManual;
	document.getElementById("NtpServer4").disabled=isManual;
	document.getElementById("NtpServer5").disabled=isManual;

	document.getElementById("NtpNoSel1").disabled=isManual;
	document.getElementById("NtpNoSel2").disabled=isManual;
	document.getElementById("NtpNoSel3").disabled=isManual;
	document.getElementById("NtpNoSel4").disabled=isManual;
	document.getElementById("NtpNoSel5").disabled=isManual;

	document.getElementById("BootDelay").disabled=isManual;
}

-->
</script>
<br/>
<?php
echo "Time Zone: ";
echo "<select name='tzarea' id='RegionSelect' onchange='selectRegion()'>\n";
$activeArea=$timezones['Africa'];

foreach($timezones as $name => $val){
	if (isset($tzmap[$name])){
		if ($name==$tzarea){
		     echo "<option selected='selected' value='$name'>", htmlspecialchars($tzmap[$name]), "</option>\n";
			$activeArea=$val;
		}else 
		     echo "<option value='$name'>", htmlspecialchars($tzmap[$name]), "</option>\n";
	}
}
echo "</select>\n";
echo "  <select id='CitySelect' name='tzcity'>\n";
foreach($activeArea as $name => $path){
	if ($name==$tzcity)
	     echo "<option selected='selected' value=\"", htmlspecialchars($path), "\">", htmlspecialchars($name), "</option>\n";
	else 
	     echo "<option value=\"", htmlspecialchars($path), "\">", htmlspecialchars($name), "</option>\n";	
}
echo "</select><br/>\n";

?>
<br/>
<input type="submit" value="Apply" name='tzupdate' />
</form>
<br/>
<h2>Change Time: </h2>
<form action="timesettings.php" method="post">
<?php

if ($ntp->active) {
	$fixChecked="";
	$ntpChecked="checked='checked'";
	$ntpDisabled="";
	$fixDisabled="disabled='disabled'";
}else{
	$fixChecked="checked='checked'";
	$ntpChecked="";
	$ntpDisabled="disabled='disabled'";
	$fixDisabled="";
}
echo "<h3><input type='radio' name='manualtime' value='1' onclick='timeSettings(true)' $fixChecked /> Manual Time Settings:</h3>\n";
echo "<table id='ManualTimeSettings'>\n";
		
$min=date("i")+1;
$hour=date("H");
if ($min==60){
	$min=0;
	$hour++;
	if ($hour==24) $hour=23;
}
$day=date("j");
$month=date("m");
$year=date("Y");

echo "<tr><td>Date (DD MM YYYY): </td><td><select name='dateday' id='DateDaySelect' $fixDisabled>\n";
for ($i=1; $i<=31; $i++){
	if ($i==$day)
		echo "<option selected='selected' value='$i'>$i</option>\n";
	else 
		echo "<option value='$i'>$i</option>\n";
}
echo "</select>\n";
$months=array("January","February","March","April","May","June","July","August","September","October","November","December");
echo "<select name='datemonth' id='DateMonthSelect' $fixDisabled>\n";
for ($i=1; $i<=12; $i++){
	if ($i==$month)
		echo "<option selected='selected' value='$i'>".$months[$i-1]."</option>\n";
	else 
		echo "<option value='$i'>".$months[$i-1]."</option>\n";
}
echo "</select>\n";
echo "<select name='dateyear' id='DateYearSelect' $fixDisabled>\n";
for ($i=2000; $i<2021; $i++){
	if ($i==$year)
		echo "<option selected='selected' value='$i'>$i</option>\n";
	else 
		echo "<option value='$i'>$i</option>\n";
}
echo "</select></td></tr>\n";
//echo " Time: <input size='20' type='text' name='time' value=''/>";
echo "<tr><td>Time: </td><td><select name='timeh' id='TimeHSelect' $fixDisabled>\n";
for ($i=0; $i<24; $i++){
	if ($i==$hour)
		echo "<option selected='selected' value='$i'>$i</option>\n";
	else 
		echo "<option value='$i'>$i</option>\n";
}
echo "</select>\n";
echo "<select name='timem' id='TimeMSelect' $fixDisabled>\n";
for ($i=0; $i<60; $i++){
	if ($i==$min)
		echo "<option selected='selected' value='$i'>$i</option>\n";
	else 
		echo "<option value='$i'>$i</option>\n";
}
echo "</select>\n";
echo "<select name='times' id='TimeSSelect' $fixDisabled>\n";
for ($i=0; $i<60; $i++){
	if ($i==0)
		echo "<option selected='selected' value='$i'>$i</option>\n";
	else 
		echo "<option value='$i'>$i</option>\n";
}
echo "</select></td></tr>\n";


echo "</table>\n";

echo "<h3><input type='radio' name='manualtime' value='0' onclick='timeSettings(false)' $ntpChecked />NTP Server:</h3>\n";
echo "<table id='NtpServers'>\n";

print("<tr><td/><td/><td/><td align='center'>Monitor only</td></tr>");
print("<tr><td/><td>Server 1 :</td><td><input size='40' type='text' name='ntpserver1' id='NtpServer1' value=\"" .
      htmlspecialchars($ntp->ntpserver1). "\" $ntpDisabled/></td><td align='center'>" .
      "<input type='checkbox' name='ntpnosel1' id='NtpNoSel1' value='yes' " . checked($ntp->ntpnosel1) . " $ntpDisabled/></td></tr>\n");
print("<tr><td/><td>Server 2 :</td><td><input size='40' type='text' name='ntpserver2' id='NtpServer2' value=\"" .
      htmlspecialchars($ntp->ntpserver2). "\" $ntpDisabled/></td><td align='center'>" .
      "<input type='checkbox' name='ntpnosel2' id='NtpNoSel2' value='yes' " . checked($ntp->ntpnosel2) . " $ntpDisabled/></td></tr>\n");
print("<tr><td/><td>Server 3 :</td><td><input size='40' type='text' name='ntpserver3' id='NtpServer3' value=\"" .
      htmlspecialchars($ntp->ntpserver3). "\" $ntpDisabled/></td><td align='center'>" .
      "<input type='checkbox' name='ntpnosel3' id='NtpNoSel3' value='yes' " . checked($ntp->ntpnosel3) . " $ntpDisabled/></td></tr>\n");
print("<tr><td/><td>Server 4 :</td><td><input size='40' type='text' name='ntpserver4' id='NtpServer4' value=\"" .
      htmlspecialchars($ntp->ntpserver4). "\" $ntpDisabled/></td><td align='center'>" .
      "<input type='checkbox' name='ntpnosel4' id='NtpNoSel4' value='yes' " . checked($ntp->ntpnosel4) . " $ntpDisabled/></td></tr>\n");
print("<tr><td/><td>Server 5 :</td><td><input size='40' type='text' name='ntpserver5' id='NtpServer5' value=\"" .
      htmlspecialchars($ntp->ntpserver5). "\" $ntpDisabled/></td><td align='center'>" .
      "<input type='checkbox' name='ntpnosel5' id='NtpNoSel5' value='yes' " . checked($ntp->ntpnosel5) . " $ntpDisabled/></td></tr>\n");
print("<tr><td/><td colspan='3'>Pause device at startup to wait for NTP servers by\n");
print("<select name='bootdelay' id='BootDelay' $ntpDisabled>\n");
$matched = false;
foreach ($bootdelays as $val) {
     if ( ! $matched && $ntp->bootdelay < $val ) {
	  $matched = true;
	  $val2 = $ntp->bootdelay;
	  echo "<option value=\"", htmlspecialchars($val2),
	       "\" selected='selected'>", htmlspecialchars($val2), " s</option>\n";
     }
     echo "<option value=\"", htmlspecialchars($val), "\" ";
     if ( ! $matched && $ntp->bootdelay == $val ) {
	  $matched = true;
	  print("selected='selected'");
     }
     echo ">", htmlspecialchars($val), " s</option>\n";
}
if ( ! $matched ) {
     $val = $ntp->bootdelay;
     echo "<option value=\"", htmlspecialchars($val),
	  "\" selected='selected'>", htmlspecialchars($val). " s</option>\n";
}     
print("</select></td></tr>\n");
?>
</table>
<p>Note: all servers specified by IP address and the last server specified by name
       will be used for initial synchronization at device startup, even if only monitored.</p>
<input type="submit" value="Apply" name='timeupdate' />

</form>
<?php
	echo "<br/><h2>NTP statistics</h2>\n";
	$nr_servers = printNTPStats($ntp->nr_sync_servers);
	if ($nr_servers >= 0 && $nr_servers < $ntp->nr_servers) {
	     if ($nr_servers == 0) {
		  echo "<p>Note: the table shows no servers,\n";
	     } else {
		  echo "<p>Note: the table shows fewer servers than what are configured,\n";
	     }
	     echo "probably due to network name(s) which cannot be resolved to IP addresses. " .
		  "The cause can be a mistyped server name, a retired server name or an " .
		  "unreachable DNS server. Please check your NTP and network configuration. " .
		  "If the failure is transient the system will recover in a few hours ".
		  "without the need for any user intervention.</p>";
	}
	echo "<form action='timesettings.php' method='post' >\n";
	echo "<input type='submit' value='Refresh' name='reload'/>\n";
	echo "</form><br/>\n";
}
include ("final.php");
?>
