<?php
$title="Firmware Update";
include ("prolog.php");

$updaterfile='/etc/updater.conf';
if (isset($_POST['reset'])){
	exec("/etc/spinetix/config.d/updater reset",$dummy,$ret);
	if ($ret!=0) echo "Cannot reset the update configuration<br/>";
}

$conf=file_get_contents($updaterfile);
if ($conf) {
	$domdoc = new DOMDocument;
	$domdoc->loadXML($conf);
	$rep=$domdoc->getElementsByTagName("repository");
	foreach ($rep as $r){
		if ($r->getAttribute("id")!="hmp100")
			continue;
		$loc=$r->getElementsByTagName("location");
		foreach ($loc as $l){
			$href=$l->getAttribute("href");
			if (isset($_POST['updater']) && isset($_POST['updateuri'])){
				$href=$_POST['updater'];
				$l->setAttribute("href",$href);
				save_file($updaterfile, $domdoc->saveXML());	
			}
		}
	}
}else {
	$href="<not supported>";
}

$timefile="/etc/cron.d/updater";

if ( isset($_POST['updateauto']) ){
	if (!isset($_POST['time']))
		$time=-1;
	else
		$time = $_POST['time'];
	$content="PATH=/usr/bin:/bin:/usr/sbin:/sbin\n";
	if ($time==-1){
		$content.="#0 -1 * * * root /usr/sbin/updater\n";
	}else if ($time>=0 && $time<24){
		$content.="0 $time * * * root /usr/sbin/updater\n";
	}else {
	     echo "Non supported time '", htmlentities($time), "' no set<br/> ";
	}
	save_file($timefile, $content);	
}else{
	$conf=file_get_contents($timefile);
	if (!$conf || $conf=="")
		$time=-1;
	elseif (preg_match("@^\s*(\d+)\s+(\d+).*/usr/sbin/updater@m",$conf,$matches))
		$time=$matches[2];
	else 
		$time=-1;
}
$nbUpdates=0;
$status=-1;
$updater_fallback=FALSE; // if only the updater is updated
$update_info=array();

function checkUpdateInfo($line) {
     global $update_info;
     global $updater_fallback;
     if (preg_match("/---\s+(FIRMWARE|UPDATER)\s+([^-]+)-([^-]+)\s+---$/",
		    $line, $matches)) {
	  $update_info['type'] = $matches[1];
	  $update_info['ver'] = $matches[2];
	  $update_info['rel'] = $matches[3];
     } elseif (preg_match("/---\s+RETRY UPDATER ONLY\s+---$/", $line)) {
	  $updater_fallback = TRUE;
     }
}

if ( isset($_POST['checkupdate']) ) {
	
	echo "<h2>Checking for Updates</h2>";
	echo "This operation might take some time.".str_repeat(' ',256)."<br/>\n";
	ob_flush();flush();
	
	$cmd='/usr/sbin/updater --log-to-stderr --lock-timeout=-1';
	$doUpdate=true;
	if ($_POST['source']=='default') $cmd .=' --max-wait-time=-1';
	else {
		$cmd .=' --repo=local-usb';
		// check for the presence of the key 
		$mount=file_get_contents("/proc/mounts");
		$mounts=explode("\n",$mount);
		$usbContent=false;
		$usbUpdate=false;
		foreach ($mounts as $mount){
			$info=preg_split("/\s/",$mount);
			if (count($info)>2){
				if ($info[1]=='/srv/raperca/content') $usbContent=true;
				if ($info[1]=='/media/usb1') $usbUpdate=true;
			}
		}
		if (!$usbUpdate){
			if ($usbContent) echo "<br/>USB storage is used as Local Storage.<br/>Please disable it using the <a href='playerconfig.php'>Media Source</a> page before doing the update.<br/>";
			else echo "<br/>No USB storage Found.<br/>";
			$doUpdate=false;
		}elseif (!file_exists("/media/usb1/updates")){
			echo "<br/>USB storage found but folder <strong>/updates</strong> doesn't exist.<br/>";
			$doUpdate=false;
		}
		
	}
	
	$cmd .=' -n';
	if ($doUpdate) {
	     $fd_desc = array(
		  0 => array("file", "/dev/null", "r"), // no stdin
		  1 => array("pipe", "w"), // read from stdout
		  2 => array("file", "/dev/null", "w"), // discard stderr
		  );
	     $updater_proc = proc_open('exec '.$cmd.' 2>&1', $fd_desc, $updater_pipes);
	     if (is_resource($updater_proc)) {
		  echo "<h3>Update log</h3>\n";
		  echo "<div class='logs'>\n";
		  while(!feof($updater_pipes[1])) {
		       $line = fgets($updater_pipes[1]);
		       if (strstr($line,"UPDATE(S) ---")){
			    $vals=explode(" ",$line);
			    if (count($vals)>3) $nbUpdates=$vals[2];
		       }
		       checkUpdateInfo($line);
		       echo htmlentities($line)."<br/>\n";
		       ob_flush();flush();
		  }
		  echo "</div>\n";
		  fclose($updater_pipes[1]);
		  $status = proc_close($updater_proc);
	     }
	     if ($status==0) {
		  if ($nbUpdates==0){
		       echo "<h3>No updates available</h3>";
		  } else {
		       echo "<h3>", htmlspecialchars($nbUpdates), " updates available</h3>\n";
		       echo "<p>";
		       if ($update_info['type'] == 'FIRMWARE') {
			    echo "Updating now would install firmware version " .
				 htmlspecialchars($update_info['ver']) .
				 " (build " . htmlspecialchars($update_info['rel']) . ").\n";
		       } elseif ($update_info['type'] == 'UPDATER') {
			    echo "Updating now would install updater version " .
				 htmlspecialchars($update_info['ver']) .
				 " (build " . htmlspecialchars($update_info['rel']) .
				 "), which is required to " .
				 "perform other updates.\n";
		       } else {
			    echo "Update would only install some minor components.\n";
		       }
		       echo "<br/>\n";
		       echo "Information about new firmware releases is available at<br/>\n";
		       echo "<a href='http://www.spinetix.com/hmp100/firmware'>http://www.spinetix.com/hmp100/firmware</a>.</p>\n";
		  }
	     }
	}else{
		unset($_POST['checkupdate']);
	}
}
if ( isset($_POST['doupdate']) ) {
	echo "<h2>Updating</h2>";
	echo "This operation might take some time. <br/>\n";
	echo "The HMP100 will restart automatically at the end of the update process. <br/>\n";
	echo "<strong>Do not un-plug the device during the update.</strong><br/>\n";

	ob_flush();flush();
	
	$cmd='/usr/sbin/updater --log-to-stderr --lock-timeout=-1';
	
	if ($_POST['source']=='default') $cmd .=' --max-wait-time=-1';
	else $cmd .=' --repo=local-usb';
	//$cmd .= ' -N'; // FOR DEBUG
	
	$fd_desc = array(
	     0 => array("file", "/dev/null", "r"), // no stdin
	     1 => array("pipe", "w"), // read from stdout
	     2 => array("file", "/dev/null", "w"), // discard stderr
	     );

	$updater_proc = proc_open('exec '.$cmd.' 2>&1', $fd_desc, $updater_pipes);

	if (is_resource($updater_proc)) {
	     echo "<h3>Update log</h3>\n";
	     echo "<div class='logs'>\n";
	     while(!feof($updater_pipes[1])) {
		  $line = fgets($updater_pipes[1]);
		  checkUpdateInfo($line);
		  echo htmlentities($line)."<br/>\n";
		  ob_flush();flush();
	     }
	     echo "</div>\n";
	     fclose($updater_pipes[1]);
	     $status = proc_close($updater_proc);
	}
	if ($status==0) {
	     echo "<p>";
	     if ($update_info['type'] == 'FIRMWARE') {
		  echo "Installed firmware version " . htmlspecialchars($update_info['ver']) .
		       " (build " . htmlspecialchars($update_info['rel']) . ").\n";
	     } elseif ($update_info['type'] == 'UPDATER') {
		  echo "Installed updater version " . htmlspecialchars($update_info['ver']) .
		       " (build " . htmlspecialchars($update_info['rel']) .
		       "), which is required to " .
		       "perform other updates.\n";
	     } else {
		  echo "Installed some minor components.\n";
	     }
	     if ($updater_fallback) {
		  echo "<br/>\n";
		  echo "Other updates are still awaiting installation, please check ".
		       "for updates again and perform an update if any are proposed ".
		       "in order to have an up to date firmware.\n";
	     }
	     echo "</p>";
	}
}

if (isset($_POST['checkupdate']) || isset($_POST['doupdate'])){
	if ($status==1)
	     echo "Update failed.<br/><br/>\n";
	elseif ($status==2)
	     echo "<strong>Fatal error during update.</strong>. Update failed, the HMP100 might not be usable anymore. It is recomended to contact support (<a href='mailto:support@spinetix.com' >support@spinetix.com</a>) and reinstall the firmware from a firmare image package in diagnostic mode.<br/>Please reboot in diagnostic mode to proceed with reinstallation.<br/><br/>";
	elseif ($status!=0)
	     echo "Failed starting update process.<br/><br/>\n";
	
	echo "<form action='update.php' method='post' >\n";
	if ($status!=0){
		echo "<input type='submit' value='Cancel' name='reload'/>\n";
	
	}else if ($nbUpdates){
	     echo "<input type='hidden' value=\"". htmlspecialchars($_POST['source'])."\" name='source'/>\n";
		echo "<input type='submit' value='Update Now' name='doupdate'/>\n";
		echo "<input type='submit' value='Cancel' name='reload'/><br/><br/>\n";
		echo "The HMP100 will restart automatically at the end of the update process. <br/>\n";
		echo "<strong>Do not un-plug the device during the update</strong><br/><br/>";
	}else if ($updater_fallback){
	     echo "<input type='hidden' value=\"". htmlspecialchars($_POST['source'])."\" name='source'/>\n";
		echo "<input type='submit' value='Check for Updates' name='checkupdate'/>\n";
		echo "<input type='submit' value='Cancel' name='reload'/><br/><br/>\n";
		echo "<p>Information about new firmware releases is available at<br/>\n";
		echo "<a href='http://www.spinetix.com/hmp100/firmware'>http://www.spinetix.com/hmp100/firmware</a>.</p>\n";
	}else{
		echo "<input type='submit' value='OK' name='reload'/><br/><br/>\n";
		echo "<p>Information about new firmware releases is available at<br/>\n";
		echo "<a href='http://www.spinetix.com/hmp100/firmware'>http://www.spinetix.com/hmp100/firmware</a>.</p>\n";
	}
	echo "</form><br/>\n";
} else {
?>

<script type="text/javascript">
<!--
function autoUpdate()
{
	var checkUpdateAr=document.getElementById("AutoUpdateCheck");
	var selectUpdate=document.getElementById("AutoUpdateTime");
	selectUpdate.disabled=!checkUpdateAr.checked;
}


-->
</script>


<h2>Current Versions: </h2>
<table>
<?php

$output=array();
exec("rpm -q --queryformat '%{VERSION}\n%{RELEASE}\n' spinetix-release updater",$output);
if (count($output)==4 ){
     print("<tr><td>Firmware: </td><td>" .htmlspecialchars($output[0])."</td><td>(build ".
	   htmlspecialchars($output[1]). ")</td></tr>\n");
     print("<tr><td>Updater: </td><td>". htmlspecialchars($output[2])."</td><td>(build ".
	   htmlspecialchars($output[3]). ")</td></tr>\n");
} else {
	print("<tr><td>Firmware error: please contact <a href='mailto:support@spinetix.com' >support@spinetix.com</a></td></tr>\n");
}
?>
</table>
<p>Information about new firmware releases is available at<br/>
<a href='http://www.spinetix.com/hmp100/firmware'>http://www.spinetix.com/hmp100/firmware</a>.
</p>


<h2>Update Server</h2>
<form action="update.php" method="post" >
<br/>
Server URI: <input size='50' type='text' name='updater' value="<?php echo htmlspecialchars($href); ?>"/><br/><br/>
<input type="submit" value="Apply" name="updateuri"/> <input type="submit" value="Reset to Default" name="reset"/>
</form>
<br/>
<h2>Automatic Update</h2>
<form action="update.php" method="post" >
<br/>
<?php

$disabledUpdateTime="";
print ("<input type='checkbox' id='AutoUpdateCheck' onclick='autoUpdate()' name='autoupdate'");
if ($time!=-1){
	 print ("checked='checked' />");
}else{
	print ("/>");
	$disabledUpdateTime="disabled='disabled' ";
}
echo "Enable automatic updates<br/><br/>\n";
echo "Update time: <select id='AutoUpdateTime' name='time' $disabledUpdateTime>";
for ($i=0; $i<24; $i++) {
	echo "<option value='$i'"; 
	if ($i==$time) echo " selected='selected'";
	echo ">$i:00</option>\n";	
}
?>
</select> <br/><br/>
<input type="submit" value="Apply" name="updateauto"/>
</form>
<br/>
<h2>Manual Update</h2>
<form action="update.php" method="post" >
<br/>
Update source : 
<select id='ManualUpdateSource' name='source'>
<option value='default'>From server</option>
<option value='usb'>From USB key</option>
</select>

<input type="submit" value="Check for Updates" name="checkupdate"/> 
</form>
<br/>
<?php

echo "<h2>Updater Info</h2>";

$statusFileName='/var/lib/updater/status';
$logFileName='/var/log/updater/lastlog';
$statusStr=array('READY'=>"Updater ready for updates",
				 'DELAYING'=>"Waiting for download",
				 'ANALYZING'=>"Analyzing system and repository for updates",
				 'DOWNLOADING'=>"Downloading packages to be updated / installed",
				 'TESTING'=>"Testing package install",
				 'UPDATING'=>"Updating / installing packages",
				 'PKGSDONE'=>"Finished updating / testing the packages",
				 'CORRUPTED'=>"Previous run was interrupted while updating / installing packages; System is most probably corrupted",
				 'REBOOTING'=>"Finished updating, device is rebooting",
				 );
$status=trim(file_get_contents($statusFileName));
if ($status=="") $status='READY';

echo "<h3>Current status: </h3>".$statusStr[$status]."<br/><br/>";
if ($status!='READY'){
	echo "<br/><form action='update.php' method='post' >To update the status, press the reload button of your browser, or ";
	echo "<input type='submit' value='Reload now' /></form><br/>";
}
$status=file_get_contents($logFileName);
if ($status!=""){
	echo "<h3>Last update log (".date ( "F d Y H:i:s", filemtime($logFileName))." ):</h3>\n<div class='logs'>\n";
	$lines=split("\n",$status);
	foreach ($lines as $line){
		echo htmlentities($line)."<br/>\n";
	}
	echo "</div>\n";
}

}
?>

<?php
include ("final.php");
?>
